unit Main_Unit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Data_Unit, GPP_Unit, StdCtrls, ExtCtrls, ComCtrls, Mask;

type
  TMain_Form = class(TForm)
    Status_GroupBox: TGroupBox;
    StatusStatus_Edit: TEdit;
    StatusTitle_Edit: TEdit;
    StatusShow_Button: TButton;
    Main_ColorDialog: TColorDialog;
    StatusColor_Panel: TPanel;
    StatusInfo_Label: TLabel;
    StatusTitleTitle_Label: TLabel;
    StatusStatusTitle_Label: TLabel;
    StatusColorTitle_Label: TLabel;
    StatusColorViewTitle_Label: TLabel;
    StatusColorView_TrackBar: TTrackBar;
    StatusTitle_CheckBox: TCheckBox;
    StatusMinWidthTitle_Label: TLabel;
    StatusMinWidth_Edit: TEdit;
    StatusViewTimeTitle_Label: TLabel;
    StatusViewTime_Edit: TEdit;
    StatusReset_Button: TButton;
    StatusBlackBackground_CheckBox: TCheckBox;
    Menu_GroupBox: TGroupBox;
    MenuShow_Button: TButton;
    MenuReset_Button: TButton;
    MenuBlackBackground_CheckBox: TCheckBox;
    MenuMinWidth_Edit: TEdit;
    MenuBorderColorView_TrackBar: TTrackBar;
    MenuBorderColorViewTitle_Label: TLabel;
    MenuTitle_Edit: TEdit;
    MenuTitleTitleLabel: TLabel;
    Label6: TLabel;
    MenuMinWidthTitle_Label: TLabel;
    MenuMinHeightTitle_Label: TLabel;
    MenuMinHeight_Edit: TEdit;
    MenuBorderCharTitle_Label: TLabel;
    MenuBorderChar_Edit: TEdit;
    MenuBorderColorTitle_Label: TLabel;
    MenuBorderColor_Panel: TPanel;
    MenuMainStringColorTitle_Label: TLabel;
    MenuMainStringColor_Panel: TPanel;
    MenuSelectedColorTitle_Label: TLabel;
    MenuSelectedColor_Panel: TPanel;
    MenuMainStringColorViewTitle_Label: TLabel;
    MenuMainStringColorView_TrackBar: TTrackBar;
    MenuSelectedColorViewTitle_Label: TLabel;
    MenuSelectedColorView_TrackBar: TTrackBar;
    MenuEntryTitle_Label: TLabel;
    MenuEntryTextTitle_Label: TLabel;
    MenuEntryStatusTitle_Label: TLabel;
    MenuEntryText_Edit: TEdit;
    MenuEntryStatus_Edit: TEdit;
    MenuEntryStatusColor_Panel: TPanel;
    MenuEntryStatusColorView_TrackBar: TTrackBar;
    MenuEntryType_ComboBox: TComboBox;
    MenuEntryStatusColorTitle_Label: TLabel;
    MenuEntryTypeTitle_Label: TLabel;
    MenuViewTimeTitle_Label: TLabel;
    MenuViewTime_Edit: TEdit;
    MenuSelectedEntryTitle_Label: TLabel;
    MenuSelectedEntry_Edit: TEdit;
    MenuEntry_ComboBox: TComboBox;
    CopyrightInfo_Label: TLabel;
    procedure StatusShow_ButtonClick(Sender: TObject);
    procedure StatusColor_PanelClick(Sender: TObject);
    procedure StatusMinWidth_EditKeyPress(Sender: TObject; var Key: Char);
    procedure StatusViewTime_EditKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure StatusReset_ButtonClick(Sender: TObject);
    procedure MenuBorderColor_PanelClick(Sender: TObject);
    procedure MenuMainStringColor_PanelClick(Sender: TObject);
    procedure MenuSelectedColor_PanelClick(Sender: TObject);
    procedure MenuEntry_ComboBoxChange(Sender: TObject);
    procedure MenuEntryText_EditChange(Sender: TObject);
    procedure MenuEntryStatus_EditChange(Sender: TObject);
    procedure MenuEntryStatusColor_PanelClick(Sender: TObject);
    procedure MenuShow_ButtonClick(Sender: TObject);
    procedure MenuReset_ButtonClick(Sender: TObject);
    procedure MenuEntryStatusColorView_TrackBarChange(Sender: TObject);
    procedure MenuEntryType_ComboBoxChange(Sender: TObject);
    procedure MenuTitle_EditChange(Sender: TObject);
    procedure MenuMinWidth_EditKeyPress(Sender: TObject; var Key: Char);
    procedure MenuMinHeight_EditKeyPress(Sender: TObject; var Key: Char);
    procedure MenuMinWidth_EditChange(Sender: TObject);
    procedure MenuMinHeight_EditChange(Sender: TObject);
    procedure MenuBorderChar_EditChange(Sender: TObject);
    procedure MenuBorderColorView_TrackBarChange(Sender: TObject);
    procedure MenuMainStringColorView_TrackBarChange(Sender: TObject);
    procedure MenuSelectedColorView_TrackBarChange(Sender: TObject);
    procedure MenuBlackBackground_CheckBoxClick(Sender: TObject);
    procedure MenuViewTime_EditKeyPress(Sender: TObject; var Key: Char);
    procedure MenuSelectedEntry_EditKeyPress(Sender: TObject;
      var Key: Char);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Main_Form: TMain_Form;

  MenuTemplateData: GPPMenuData;
  MenuData: GPPMenuData;

  procedure StatusReset;
  procedure MenuReset;

implementation

{$R *.dfm}

//Hauptfenster
procedure TMain_Form.FormCreate(Sender: TObject);
begin
  //Menu definieren
  MenuTemplateData.GPPMenuTitle := '* Men-Beispiel *';
  MenuTemplateData.GPPMenuMinWidth := 0;
  MenuTemplateData.GPPMenuMinHeight := 0;
  MenuTemplateData.GPPMenuBorderCharacter := '*';
  MenuTemplateData.GPPMenuBorderColor := $ffffff00;
  MenuTemplateData.GPPMenuSelectedStringColor := $7f0000ff;
  MenuTemplateData.GPPMenuMainStringColor := $ffffffff;
  MenuTemplateData.GPPMenuUseBlackBackground := true;

  MenuTemplateData.GPPMenuEntrys := 9;
  MenuTemplateData.GPPMenuEntryFirstString[0] := '123456789012345678901234567890';
  MenuTemplateData.GPPMenuEntrySecondStringColor[0] := $ffff0000;
  MenuTemplateData.GPPMenuEntryFirstString[1] := 'Eintrag 2 (Normal)';
  MenuTemplateData.GPPMenuEntryFirstString[2] := 'Eintrag 3 (Zentriert)';
  MenuTemplateData.GPPMenuEntryType[2] := 1;
  MenuTemplateData.GPPMenuEntryFirstString[3] := 'Eintrag 4 (Status): ';
  MenuTemplateData.GPPMenuEntrySecondString[3] := 'Status';
  MenuTemplateData.GPPMenuEntrySecondStringColor[3] := $ffff0000;
  MenuTemplateData.GPPMenuEntryType[3] := 2;
  MenuTemplateData.GPPMenuEntryFirstString[4] := '123456789012345678901234567890';
  MenuTemplateData.GPPMenuEntryFirstString[5] := 'Eintrag 6';
  MenuTemplateData.GPPMenuEntryFirstString[6] := 'Eintrag 7';
  MenuTemplateData.GPPMenuEntryFirstString[7] := 'Eintrag 8';
  MenuTemplateData.GPPMenuEntryFirstString[8] := 'Eintrag 9';

  StatusReset;
  MenuReset;
end;

//Status
procedure TMain_Form.StatusColor_PanelClick(Sender: TObject);
begin
  if Main_ColorDialog.Execute = true then
    StatusColor_Panel.Color := Main_ColorDialog.Color;
end;

procedure TMain_Form.StatusMinWidth_EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) < Ord('0')) or (Ord(Key) > Ord('9')) then
    Key := Chr(8);
end;

procedure TMain_Form.StatusViewTime_EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) < Ord('0')) or (Ord(Key) > Ord('9')) then
    Key := Chr(8);
end;

procedure TMain_Form.StatusReset_ButtonClick(Sender: TObject);
begin
  StatusReset;
end;

procedure TMain_Form.StatusShow_ButtonClick(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  RedValue := StatusColor_Panel.Color;
  GreenValue := StatusColor_Panel.Color div 256;
  BlueValue := StatusColor_Panel.Color div 65536;

  if StatusMinWidth_Edit.Text = '' then
    StatusMinWidth_Edit.Text := '0';

  if StatusViewTime_Edit.Text = '' then
    StatusViewTime_Edit.Text := '0';

  GPPTextStatusShow(StatusTitle_Edit.Text, StatusStatus_Edit.Text, GPPColorValue(StatusColorView_TrackBar.Position, RedValue, GreenValue, BlueValue), Ord(StatusTitle_CheckBox.Checked), StrToInt(StatusMinWidth_Edit.Text), StrToInt(StatusViewTime_Edit.Text), StatusBlackBackground_CheckBox.Checked);
end;

//Men
procedure TMain_Form.MenuTitle_EditChange(Sender: TObject);
begin
  MenuData.GPPMenuTitle := Main_Form.MenuTitle_Edit.Text;
end;

procedure TMain_Form.MenuMinWidth_EditChange(Sender: TObject);
begin
  if Main_Form.MenuMinWidth_Edit.Text <> '' then
    MenuData.GPPMenuMinWidth := StrToInt(Main_Form.MenuMinWidth_Edit.Text);
end;

procedure TMain_Form.MenuMinWidth_EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) < Ord('0')) or (Ord(Key) > Ord('9')) then
    Key := Chr(8);
end;

procedure TMain_Form.MenuMinHeight_EditChange(Sender: TObject);
begin
  if Main_Form.MenuMinHeight_Edit.Text <> '' then
    MenuData.GPPMenuMinHeight := StrToInt(Main_Form.MenuMinHeight_Edit.Text);
end;

procedure TMain_Form.MenuMinHeight_EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) < Ord('0')) or (Ord(Key) > Ord('9')) then
    Key := Chr(8);
end;

procedure TMain_Form.MenuBorderChar_EditChange(Sender: TObject);
begin
  MenuData.GPPMenuBorderCharacter := Chr(Asc(Main_Form.MenuBorderChar_Edit.Text));
end;

procedure TMain_Form.MenuBorderColor_PanelClick(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  if Main_ColorDialog.Execute = true then
    MenuBorderColor_Panel.Color := Main_ColorDialog.Color;

  RedValue := MenuBorderColor_Panel.Color;
  GreenValue := MenuBorderColor_Panel.Color div 256;
  BlueValue := MenuBorderColor_Panel.Color div 65536;

  MenuData.GPPMenuBorderColor := GPPColorValue(MenuBorderColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuBorderColorView_TrackBarChange(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  RedValue := MenuBorderColor_Panel.Color;
  GreenValue := MenuBorderColor_Panel.Color div 256;
  BlueValue := MenuBorderColor_Panel.Color div 65536;

  MenuData.GPPMenuBorderColor := GPPColorValue(MenuBorderColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuMainStringColor_PanelClick(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  if Main_ColorDialog.Execute = true then
    MenuMainStringColor_Panel.Color := Main_ColorDialog.Color;

  RedValue := MenuMainStringColor_Panel.Color;
  GreenValue := MenuMainStringColor_Panel.Color div 256;
  BlueValue := MenuMainStringColor_Panel.Color div 65536;

  MenuData.GPPMenuMainStringColor := GPPColorValue(MenuMainStringColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuMainStringColorView_TrackBarChange(
  Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  RedValue := MenuMainStringColor_Panel.Color;
  GreenValue := MenuMainStringColor_Panel.Color div 256;
  BlueValue := MenuMainStringColor_Panel.Color div 65536;

  MenuData.GPPMenuMainStringColor := GPPColorValue(MenuMainStringColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuSelectedColor_PanelClick(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  if Main_ColorDialog.Execute = true then
    MenuSelectedColor_Panel.Color := Main_ColorDialog.Color;

  RedValue := MenuSelectedColor_Panel.Color;
  GreenValue := MenuSelectedColor_Panel.Color div 256;
  BlueValue := MenuSelectedColor_Panel.Color div 65536;

  MenuData.GPPMenuSelectedStringColor := GPPColorValue(MenuSelectedColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuSelectedColorView_TrackBarChange(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  RedValue := MenuSelectedColor_Panel.Color;
  GreenValue := MenuSelectedColor_Panel.Color div 256;
  BlueValue := MenuSelectedColor_Panel.Color div 65536;

  MenuData.GPPMenuSelectedStringColor := GPPColorValue(MenuSelectedColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuBlackBackground_CheckBoxClick(Sender: TObject);
begin
  MenuData.GPPMenuUseBlackBackground := Main_Form.MenuBlackBackground_CheckBox.Checked;
end;

procedure TMain_Form.MenuViewTime_EditKeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) < Ord('0')) or (Ord(Key) > Ord('9')) then
    Key := Chr(8);
end;

procedure TMain_Form.MenuEntry_ComboBoxChange(Sender: TObject);
var
  AlphaValue, RedValue, GreenValue, BlueValue: UInt8;
begin
  AlphaValue := MenuData.GPPMenuEntrySecondStringColor[MenuEntry_ComboBox.ItemIndex] div 16777216;
  RedValue := MenuData.GPPMenuEntrySecondStringColor[MenuEntry_ComboBox.ItemIndex];
  GreenValue := MenuData.GPPMenuEntrySecondStringColor[MenuEntry_ComboBox.ItemIndex] div 256;
  BlueValue := MenuData.GPPMenuEntrySecondStringColor[MenuEntry_ComboBox.ItemIndex] div 65536;

  MenuEntryText_Edit.Text := MenuData.GPPMenuEntryFirstString[MenuEntry_ComboBox.ItemIndex];
  MenuEntryStatus_Edit.Text := MenuData.GPPMenuEntrySecondString[MenuEntry_ComboBox.ItemIndex];
  MenuEntryStatusColor_Panel.Color := GPPColorValue(0, RedValue, GreenValue, BlueValue);
  MenuEntryStatusColorView_TrackBar.Position := AlphaValue;
  MenuEntryType_ComboBox.ItemIndex := MenuData.GPPMenuEntryType[MenuEntry_ComboBox.ItemIndex];
end;

procedure TMain_Form.MenuEntryText_EditChange(Sender: TObject);
begin
  MenuData.GPPMenuEntryFirstString[MenuEntry_ComboBox.ItemIndex] := MenuEntryText_Edit.Text;
end;

procedure TMain_Form.MenuEntryStatus_EditChange(Sender: TObject);
begin
  MenuData.GPPMenuEntrySecondString[MenuEntry_ComboBox.ItemIndex] := MenuEntryStatus_Edit.Text;
end;

procedure TMain_Form.MenuEntryStatusColor_PanelClick(Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  if Main_ColorDialog.Execute = true then
    MenuEntryStatusColor_Panel.Color := Main_ColorDialog.Color;

  RedValue := MenuEntryStatusColor_Panel.Color;
  GreenValue := MenuEntryStatusColor_Panel.Color div 256;
  BlueValue := MenuEntryStatusColor_Panel.Color div 65536;

  MenuData.GPPMenuEntrySecondStringColor[MenuEntry_ComboBox.ItemIndex] := GPPColorValue(MenuEntryStatusColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuEntryStatusColorView_TrackBarChange(
  Sender: TObject);
var
  RedValue, GreenValue, BlueValue: UInt8;
begin
  RedValue := MenuEntryStatusColor_Panel.Color;
  GreenValue := MenuEntryStatusColor_Panel.Color div 256;
  BlueValue := MenuEntryStatusColor_Panel.Color div 65536;

  MenuData.GPPMenuEntrySecondStringColor[MenuEntry_ComboBox.ItemIndex] := GPPColorValue(MenuEntryStatusColorView_TrackBar.Position, RedValue, GreenValue, BlueValue);
end;

procedure TMain_Form.MenuEntryType_ComboBoxChange(Sender: TObject);
begin
  MenuData.GPPMenuEntryType[MenuEntry_ComboBox.ItemIndex] := MenuEntryType_ComboBox.ItemIndex;
end;

procedure TMain_Form.MenuSelectedEntry_EditKeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) < Ord('0')) or (Ord(Key) > Ord('9')) then
    Key := Chr(8);
end;

procedure TMain_Form.MenuReset_ButtonClick(Sender: TObject);
begin
  MenuReset;
end;

procedure TMain_Form.MenuShow_ButtonClick(Sender: TObject);
begin
  if Main_Form.MenuMinWidth_Edit.Text = '' then
    Main_Form.MenuMinWidth_Edit.Text := '0';

  if Main_Form.MenuMinHeight_Edit.Text = '' then
    Main_Form.MenuMinHeight_Edit.Text := '0';

  if MenuViewTime_Edit.Text = '' then
    MenuViewTime_Edit.Text := '0';

  if MenuSelectedEntry_Edit.Text = '' then
    MenuSelectedEntry_Edit.Text := '0';

  GPPTextMenuShow(MenuData, StrToInt(MenuSelectedEntry_Edit.Text), StrToInt(MenuViewTime_Edit.Text));
end;

//Funktionen
procedure StatusReset;
begin
  Main_Form.StatusTitle_Edit.Text := 'Titel';
  Main_Form.StatusTitle_CheckBox.Checked := true;
  Main_Form.StatusStatus_Edit.Text := 'Status';
  Main_Form.StatusColor_Panel.Color := $ffffff;
  Main_Form.StatusColorView_TrackBar.Position := 255;
  Main_Form.StatusMinWidth_Edit.Text := '20';
  Main_Form.StatusViewTime_Edit.Text := '5000';
  Main_Form.StatusBlackBackground_CheckBox.Checked := true;
end;

procedure MenuReset;
var
  AlphaValue, RedValue, GreenValue, BlueValue: UInt8;
begin
  MenuData := MenuTemplateData;

  Main_Form.MenuTitle_Edit.Text := MenuData.GPPMenuTitle;
  Main_Form.MenuMinWidth_Edit.Text := IntToStr(MenuData.GPPMenuMinWidth);
  Main_Form.MenuMinHeight_Edit.Text := IntToStr(MenuData.GPPMenuMinHeight);
  Main_Form.MenuBorderChar_Edit.Text := MenuData.GPPMenuBorderCharacter;
  AlphaValue := MenuData.GPPMenuBorderColor div 16777216;
  RedValue := MenuData.GPPMenuBorderColor;
  GreenValue := MenuData.GPPMenuBorderColor div 256;
  BlueValue := MenuData.GPPMenuBorderColor div 65536;
  Main_Form.MenuBorderColor_Panel.Color := GPPColorValue(0, RedValue, GreenValue, BlueValue);
  Main_Form.MenuBorderColorView_TrackBar.Position := AlphaValue;
  AlphaValue := MenuData.GPPMenuMainStringColor div 16777216;
  RedValue := MenuData.GPPMenuMainStringColor;
  GreenValue := MenuData.GPPMenuMainStringColor div 256;
  BlueValue := MenuData.GPPMenuMainStringColor div 65536;
  Main_Form.MenuMainStringColor_Panel.Color := GPPColorValue(0, RedValue, GreenValue, BlueValue);
  Main_Form.MenuMainStringColorView_TrackBar.Position := AlphaValue;
  AlphaValue := MenuData.GPPMenuSelectedStringColor div 16777216;
  RedValue := MenuData.GPPMenuSelectedStringColor;
  GreenValue := MenuData.GPPMenuSelectedStringColor div 256;
  BlueValue := MenuData.GPPMenuSelectedStringColor div 65536;
  Main_Form.MenuSelectedColor_Panel.Color := GPPColorValue(0, RedValue, GreenValue, BlueValue);
  Main_Form.MenuSelectedColorView_TrackBar.Position := AlphaValue;
  Main_Form.MenuBlackBackground_CheckBox.Checked := MenuData.GPPMenuUseBlackBackground;

  Main_Form.MenuEntry_ComboBox.ItemIndex := 0;
  Main_Form.MenuEntryText_Edit.Text := MenuData.GPPMenuEntryFirstString[0];
  Main_Form.MenuEntryStatus_Edit.Text := MenuData.GPPMenuEntrySecondString[0];
  AlphaValue := MenuData.GPPMenuEntrySecondStringColor[0] div 16777216;
  RedValue := MenuData.GPPMenuEntrySecondStringColor[0];
  GreenValue := MenuData.GPPMenuEntrySecondStringColor[0] div 256;
  BlueValue := MenuData.GPPMenuEntrySecondStringColor[0] div 65536;
  Main_Form.MenuEntryStatusColor_Panel.Color := GPPColorValue(0, RedValue, GreenValue, BlueValue);
  Main_Form.MenuEntryStatusColorView_TrackBar.Position := AlphaValue;
  Main_Form.MenuEntryStatusColorView_TrackBar.Position := AlphaValue;
  Main_Form.MenuEntryType_ComboBox.ItemIndex := MenuData.GPPMenuEntryType[0];

end;

end.
